<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 07/17/2004 *
 * ================                             Last change: 07/17/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : ext-mods.php                                     *
 * -------------------------------------------------------------------- *
 * Short description : Module management (mod_reg table)                *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Modul-Management (Tabelle mod_reg)               *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Version number
$EXT_VERSION = "0.0.8";

// Auto-set extension version
if (empty($EXT_VER)) $EXT_VER = $EXT_VERSION;

// Version history array (add more with , "0.1" and so on)
$EXT_VER_HISTORY = array("0.0", "0.0.1", "0.0.2", "0.0.3", "0.0.4", "0.0.5", "0.0.6", "0.0.7", "0.0.8");

switch ($EXT_LOAD_MODE)
{
case "register": // Do stuff when installation is running (modules.php?module=admin&action=login is called)
	// SQL commands to run
	$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_admin_menu (`action`,`what`,`title`,`descr`,`sort`) VALUES ('mods', NULL, 'Modul-Management','Verwalten Sie die Basis-Module index, login, admin usw.', 4)";
	$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_admin_menu (`action`,`what`,`title`,`descr`,`sort`) VALUES ('mods','config_mods','Module &auml;ndern','&Auml;ndern Sie hier die Zugtiffsrechte auf die Module. Was dennoch nicht geht: Mitglied- oder Gastzugriffsrtechte auf Admin-Module bzw. Gastzugriffsrechte auf Mitglieder-Module. Diese sind extra abgesichert.', 1)";
	$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_admin_menu (`action`,`what`,`title`,`descr`,`sort`) VALUES ('mods','stats_mods','Modul-Statistiken','Sehen Sie sich hier die Statistiken der Module und die damit verkn&uuml;pften action- und what-Dateien an. Bei einigen Modulen gibt es allerdings keine verkn&uuml;pften Dateien und somit keine Extra-Statistik.', 2)";
	break;

case "remove": // Do stuff when removing extension
	// SQL commands to run
	$SQLs[] = "DELETE LOW_PRIORITY FROM "._MYSQL_PREFIX."_admin_menu WHERE action='mods' LIMIT 3";
	break;

case "activate": // Do stuff when admin activates this extension
	// SQL commands to run
	$SQLs[] = "";
	break;

case "deactivate": // Do stuff when admin deactivates this extension
	// SQL commands to run
	$SQLs[] = "";
	break;

case "update": // Update an extension
	switch ($EXT_VER)
	{
	case "0.0.2": // SQL queries for v0.0.2
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Fehler beseitigt, wenn error_reporting=E_ALL gesetzt ist.";
		break;

	case "0.0.3": // SQL queries for v0.0.3
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Dummy-Release im Internet???";
		break;

	case "0.0.4": // SQL queries for v0.0.4
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Seit <A href=\"#\">Patch 340</A> &uuml;berfl&uuml;ssige HTML-Tags entfernt.";
		break;

	case "0.0.5": // SQL queries for v0.0.5
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "HTML-Code ausgelagert in Templates und SQL-Anweisungen abgesichert.";
		break;

	case "0.0.6": // SQL queries for v0.0.6
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Abspeichern von Einstellungen repariert.";
		break;

	case "0.0.7": // SQL queries for v0.0.7
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Sicherheitsupdate f&uuml;r die Include-Befehle.";
		break;

	case "0.0.8": // SQL queries for v0.0.8
		$SQLs[] = "UPDATE "._MYSQL_PREFIX."_admin_menu SET title = 'Modul-Management' WHERE action = 'mods' AND (what='' OR what IS NULL) LIMIT 1";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Verwaltung auf Management umgestellt.";
		break;
	}
	break;

default: // Do stuff when extension is loaded
	break;
}

// Language file prefix
$EXT_LANG_PREFIX = "mods";

//
?>
